(function () {
  (function () {
    (function () {
      function r(e, n, t) {
        function o(i, f) {
          if (!n[i]) {
            if (!e[i]) {
              var c = "function" == typeof require && require;
              if (!f && c) return c(i, !0);
              if (u) return u(i, !0);
              var a = new Error("Cannot find module '" + i + "'");
              throw ((a.code = "MODULE_NOT_FOUND"), a);
            }
            var p = (n[i] = { exports: {} });
            e[i][0].call(
              p.exports,
              function (r) {
                var n = e[i][1][r];
                return o(n || r);
              },
              p,
              p.exports,
              r,
              e,
              n,
              t
            );
          }
          return n[i].exports;
        }
        for (
          var u = "function" == typeof require && require, i = 0;
          i < t.length;
          i++
        )
          o(t[i]);
        return o;
      }
      return r;
    })()(
      {
        1: [
          function (require, module, exports) {
            (function (global) {
              //↓↓↓↓↓ Do not change. ↓↓↓↓↓
              function PluginObject(canvasId) {
                this.canvasId = canvasId;

                this.x = 0;
                this.y = 0;
                this.width = 0;
                this.height = 0;

                this.drillDown = null;
                this.drillUp = null;
                this.drillThrough = null;
                this.relation = null;
                this.dataPointAction = null;

                this.invalidateDisplayList = null;
                this.callLater = null;
              }

              PluginObject.prototype = {};
              PluginObject.prototype.constructor = PluginObject;
              module.exports = PluginObject;

              PluginObject.prototype.createChildren = function () {};

              PluginObject.prototype.updateDisplayList = function (
                width,
                height
              ) {};

              PluginObject.prototype.setConfig = function (config) {};

              PluginObject.prototype.setData = function (data, type) {};

              PluginObject.prototype.onMove = function (x, y) {
                this.x = x;
                this.y = y;
              };

              PluginObject.prototype.onResize = function (width, height) {
                this.width = width;
                this.height = height;
              };

              PluginObject.prototype.onMouseEvent = function (event) {};

              PluginObject.prototype.onKeyboardEvent = function (event) {};

              PluginObject.prototype.destroy = function () {};

              if (!global.JSPLUGIN) {
                global.JSPLUGIN = {};
              }
              //↑↑↑↑↑ Do not change. ↑↑↑↑↑
            }.call(
              this,
              typeof global !== "undefined"
                ? global
                : typeof self !== "undefined"
                ? self
                : typeof window !== "undefined"
                ? window
                : {}
            ));
          },
          {},
        ],
        2: [
          function (require, module, exports) {
            (function (global) {
              var PluginObject = require("./PluginObject");
              /**help
               * Please write the help text of this plugin here.
               */
              //↓↓↓↓↓ Please write your program. ↓↓↓↓↓
              function StandardWorkCombinationSlip(canvasId) {
                PluginObject.call(this, canvasId);

                //This is a sample.
                this.canvas = document.getElementById(canvasId);
                this.context2d = this.canvas.getContext("2d");
                this.config = {
                  font: "20px _sans",
                  fillStyle: "rgb(0, 0, 0)",
                  strokeStyle: "black",
                  tick: 10,
                  segmentCount: 11,
                  tactTimeLineColor: "red",
                  tactTimeLineWidth: 7,
                  tactTimeTextColor: "red",
                  tactTimeTextBaseline: "top",
                };
              }

              //↓↓↓↓↓ Do not change. ↓↓↓↓↓
              StandardWorkCombinationSlip.prototype = Object.create(
                PluginObject.prototype
              );
              StandardWorkCombinationSlip.prototype.constructor =
                StandardWorkCombinationSlip;
              module.exports = StandardWorkCombinationSlip;
              //↑↑↑↑↑ Do not change. ↑↑↑↑↑

              /**
               * プラグインアイテムの設定文字列が設定・変更された際にMotionBoardから呼び出されるメソッド
               * @param {*} config
               * 設定例
               * {
               *   "font": "italic 20px Arial",
               *   "fillStyle": "rgb(0, 0, 0)",
               *   "strokeStyle": "black",
               *   "tick": 10,
               *   "segmentCount": 11
               *   "tactTimeLineColor": "red",
               *   "tactTimeLineWidth": 7,
               *   "tactTimeTextColor": "red",
               *   "tactTimeTextBaseline": "top",
               * }
               * @memberof StandardWorkCombinationSlip
               * @method setConfig
               */
              StandardWorkCombinationSlip.prototype.setConfig = function (
                config
              ) {
                if (config === null || config.length === 0) {
                  return;
                }
                try {
                  const cfg = JSON.parse(config);
                  if ("font" in cfg) {
                    this.config.font = cfg.font;
                  }
                  if ("fillStyle" in cfg) {
                    this.config.fillStyle = cfg.fillStyle;
                  }
                  if ("strokeStyle" in cfg) {
                    this.config.strokeStyle = cfg.strokeStyle;
                  }
                  if ("tick" in cfg) {
                    this.config.tick = cfg.tick;
                  }
                  if ("segmentCount" in cfg) {
                    this.config.segmentCount = cfg.segmentCount;
                  }
                  if ("tactTimeLineColor" in cfg) {
                    this.config.tactTimeLineColor = cfg.tactTimeLineColor;
                  }
                  if ("tactTimeLineWidth" in cfg) {
                    this.config.tactTimeLineWidth = cfg.tactTimeLineWidth;
                  }
                  if ("tactTimeTextColor" in cfg) {
                    this.config.tactTimeTextColor = cfg.tactTimeTextColor;
                  }
                  if ("tactTimeTextBaseline" in cfg) {
                    this.config.tactTimeTextBaseline = cfg.tactTimeTextBaseline;
                  }
                } catch (err) {
                  this.error_message = "設定値が不正です" + err;
                }
              };

              StandardWorkCombinationSlip.prototype.setData = function (
                data,
                type
              ) {
                // 集計項目データ取得
                this.sumDataList = data.pointDataList;

                /* MBデータソースの行項目データ取得
               行項目数*集計項目数の値が配列として取得されるため、
               本処理で行項目の値の重複を排除した行項目値出力用の配列を定義 */
                this.rowDataList = [
                  ...new Map(
                    this.sumDataList.map((v) => [
                      v.colData.itemValue[0].value,
                      v,
                    ])
                  ).values(),
                ];
              };

              /**
               * チャートの描画の際にMotionBoardから呼び出されるメソッド
               * @param {float}	width	プラグインの描画領域の幅
               * @param {float}	height	プラグインの描画領域の高さ
               * @method updateDisplayList
               */
              StandardWorkCombinationSlip.prototype.updateDisplayList =
                function (width, height) {
                  // 描画エリアを透明で初期化
                  this.context2d.clearRect(0, 0, width, height);

                  // タイトル文字描画のパラメータ
                  this.context2d.strokeStyle = this.config.strokeStyle;
                  this.context2d.fillStyle = this.config.fillStyle;
                  this.context2d.lineWidth = 1;
                  this.context2d.textAlign = "center";

                  this.context2d.textBaseline = "middle";

                  this.context2d.font = this.config.font;
                  const ColPositionFrom1X = 50;
                  const ColWidth1 = 100;
                  // ヘッダー行出力位置
                  const rowPositionFrom1Y = 30;
                  // ヘッダー行高さ
                  const headerRowHeight = 80;
                  this.context2d.textBaseline = "bottom";

                  // ヘッダーテキスト出力
                  this.context2d.strokeRect(
                    ColPositionFrom1X,
                    rowPositionFrom1Y,
                    ColWidth1,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "順序",
                    ColPositionFrom1X + ColWidth1 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth2 = 200;
                  this.context2d.strokeRect(
                    ColPositionFrom1X + ColWidth1,
                    rowPositionFrom1Y,
                    ColWidth2,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "作業内容",
                    ColPositionFrom1X + ColWidth1 + ColWidth2 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth3 = 70;
                  this.context2d.strokeRect(
                    ColPositionFrom1X + ColWidth1 + ColWidth2,
                    rowPositionFrom1Y,
                    ColWidth3,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "手作業",
                    ColPositionFrom1X + ColWidth1 + ColWidth2 + ColWidth3 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth4 = 70;
                  this.context2d.strokeRect(
                    ColPositionFrom1X + ColWidth1 + ColWidth2 + ColWidth3,
                    rowPositionFrom1Y,
                    ColWidth3,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "自動",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth5 = 70;
                  this.context2d.strokeRect(
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4,
                    rowPositionFrom1Y,
                    ColWidth3,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "歩行",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth6 = 600;
                  this.context2d.strokeRect(
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5,
                    rowPositionFrom1Y,
                    ColWidth6,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "組み合わせ線図",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 +
                      ColWidth6 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth7 = 400;
                  this.context2d.strokeRect(
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 +
                      ColWidth6,
                    rowPositionFrom1Y,
                    ColWidth7,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "備考",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 +
                      ColWidth6 +
                      ColWidth7 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const widthArr = [
                    ColWidth1,
                    ColWidth2,
                    ColWidth3,
                    ColWidth4,
                    ColWidth5,
                    ColWidth6,
                    ColWidth7,
                  ];
                  const rowHeight = 100;

                  this.context2d.textBaseline = "middle";
                  // 明細表（集計項目）出力
                  // 行処理
                  for (let rowIndex = 0; rowIndex < 5; rowIndex++) {
                    const rowPosition =
                      rowPositionFrom1Y +
                      headerRowHeight +
                      rowHeight * rowIndex;
                    let ColWidthTotal = ColPositionFrom1X;

                    if (this.rowDataList.length <= rowIndex) {
                      break;
                    }

                    // 列処理
                    for (
                      let colIndex = 0;
                      colIndex < widthArr.length;
                      colIndex++
                    ) {
                      const ColWidth =
                        colIndex == 0 ? 0 : widthArr[colIndex - 1];
                      ColWidthTotal += ColWidth;
                      this.context2d.strokeRect(
                        ColWidthTotal,
                        rowPosition,
                        widthArr[colIndex],
                        rowHeight
                      );

                      // 「順序」列出力
                      if (colIndex === 0) {
                        this.context2d.fillText(
                          rowIndex + 1,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                      // 作業内容の値出力
                      if (colIndex === 1) {
                        this.context2d.fillText(
                          this.rowDataList[rowIndex].colData.itemValue[0].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }

                      // 手作業時間出力
                      if (colIndex === 2) {
                        this.context2d.fillText(
                          this.sumDataList.filter(
                            (x) => x.summaryData.value === "manual_work_time"
                          )[rowIndex].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                      // 自動時間出力
                      if (colIndex === 3) {
                        this.context2d.fillText(
                          this.sumDataList.filter(
                            (x) => x.summaryData.value === "auto_work_time"
                          )[rowIndex].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                      // 歩行時間出力
                      if (colIndex === 4) {
                        this.context2d.fillText(
                          this.sumDataList.filter(
                            (x) => x.summaryData.value === "walking_time"
                          )[rowIndex].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                    }
                  }

                  /**
                   * Canvas線描画メソッド
                   * @param {number} startX - X始点座標
                   * @param {number} startY - Y始点座標
                   * @param {number} endX - X終点座標
                   * @param {number} endY - Y終点座標
                   * @param {string} lineType - 線種
                   * @param {string} [lineWidth] - 太さ(デフォルト値は1)
                   * @param {string} [color= "black"] - 線色(デフォルト値はblack)
                   * @param {MyClass} myClass - MyClassインスタンスの引数
                   */
                  const drawLine = (
                    startX,
                    startY,
                    endX,
                    endY,
                    lineType,
                    lineWidth = 1,
                    color = "black"
                  ) => {
                    // 線のパラメータ設定
                    this.context2d.beginPath();
                    this.context2d.strokeStyle = color;
                    this.context2d.lineWidth = lineWidth;
                    if (lineType === "dash") {
                      this.context2d.setLineDash([20, 5]);
                    } else {
                      this.context2d.setLineDash([]);
                    }
                    // 始点指定
                    this.context2d.moveTo(startX, startY);
                    // 点線終点指定
                    this.context2d.lineTo(endX, endY);
                    this.context2d.stroke();
                  };

                  // 「組み合わせ線図」列の点線出力処理
                  const base =
                    ColPositionFrom1X +
                    ColWidth1 +
                    ColWidth2 +
                    ColWidth3 +
                    ColWidth4 +
                    ColWidth5;
                  this.context2d.textBaseline = "bottom";
                  const tactTimeSum = this.sumDataList
                    .filter((x) => x.summaryData.value != "auto_work_time")
                    .map((x) => x.value)
                    .reduce((sum, element) => sum + element, 0);

                  const configSumValue =
                    this.config.tick * this.config.segmentCount;
                  // 列点線の1目盛りあたりの値
                  const tick =
                    tactTimeSum > configSumValue
                      ? Math.floor(tactTimeSum / 10)
                      : this.config.tick;
                  const segmentCount =
                    tactTimeSum > configSumValue
                      ? 11
                      : this.config.segmentCount;

                  for (let i = 0; i <= segmentCount; i++) {
                    if (i === 0 || i === segmentCount) continue;
                    // ラインX座標
                    const linePositionX = base + (ColWidth6 / segmentCount) * i;

                    // 目盛り数値出力
                    this.context2d.fillText(
                      tick * i,
                      linePositionX,
                      rowPositionFrom1Y + headerRowHeight
                    );
                    // 組み合わせ基準線描画
                    drawLine(
                      linePositionX,
                      rowPositionFrom1Y + headerRowHeight,
                      linePositionX,
                      rowPositionFrom1Y +
                        headerRowHeight +
                        rowHeight * this.rowDataList.length,
                      "dash"
                    );
                  }

                  // 集計項目データを組み合わせ線描画のための連想配列の配列へ格納処理
                  let lineValueArr = [];
                  // 作業内容数でループ
                  for (
                    let rowIndex = 0;
                    rowIndex < this.rowDataList.length;
                    rowIndex++
                  ) {
                    let valueDict = {};
                    let colIndex = 0;
                    // 手作業、自動、歩行の三要素ごとにループ
                    while (colIndex < 3) {
                      // 「Key：作業要素, Value：時間」とした連想配列を作成し配列へ格納
                      valueDict[
                        this.sumDataList[
                          colIndex + 3 * rowIndex
                        ].summaryData.value
                      ] = this.sumDataList[colIndex + 3 * rowIndex].value;
                      colIndex++;
                    }
                    lineValueArr.push(valueDict);
                  }

                  const tactTime = lineValueArr
                    .map((x) => x.manual_work_time + x.walking_time)
                    .reduce((a, x) => a + x);

                  // 目盛り内の1値（1目盛り"10"であれば"1"をここで取得）
                  const tickInTime = ColWidth6 / segmentCount / tick;
                  let xPos = base;
                  // 行ごとに組み合わせ線出力処理
                  lineValueArr.map((x, rowIndex) => {
                    // 自動運転時間が
                    const xPosOffset =
                      x.auto_work_time + x.manual_work_time > tactTime
                        ? x.auto_work_time + x.manual_work_time - tactTime
                        : 0;

                    xPos = xPos + xPosOffset * tickInTime;
                    // 手作業時間描画
                    drawLine(
                      xPos,
                      rowPositionFrom1Y +
                        headerRowHeight +
                        rowHeight * rowIndex +
                        rowHeight / 2,
                      xPos + x.manual_work_time * tickInTime,
                      rowPositionFrom1Y +
                        headerRowHeight +
                        rowHeight * rowIndex +
                        rowHeight / 2,
                      "",
                      10,
                      "red"
                    );
                    xPos += x.manual_work_time * tickInTime;

                    if (x.auto_work_time > 0) {
                      const xAutoEnd =
                        xPos + x.auto_work_time * tickInTime >
                        base + tactTime * tickInTime
                          ? base +
                            tactTime * tickInTime +
                            xPosOffset * tickInTime
                          : xPos + x.auto_work_time * tickInTime;

                      // 自動運転時間の終了がタクトタイムを超える場合
                      if (
                        xPos + x.auto_work_time * tickInTime >
                        base + tactTime * tickInTime
                      ) {
                        const wraoOffsetY = 20;
                        // 自動運転出力(折返し)
                        drawLine(
                          base,
                          rowPositionFrom1Y +
                            headerRowHeight +
                            rowHeight * rowIndex +
                            rowHeight / 2 +
                            wraoOffsetY,
                          (xPos / tickInTime +
                            x.auto_work_time -
                            tactTime -
                            xPosOffset) *
                            tickInTime,
                          rowPositionFrom1Y +
                            headerRowHeight +
                            rowHeight * rowIndex +
                            rowHeight / 2 +
                            wraoOffsetY,
                          "dash",
                          3,
                          "blue"
                        );
                      }

                      // 自動運転出力(手作業後)
                      drawLine(
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * rowIndex +
                          rowHeight / 2,
                        xAutoEnd,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * rowIndex +
                          rowHeight / 2,
                        "dash",
                        3,
                        "blue"
                      );
                    }

                    // 歩行時間出力
                    let endY =
                      rowPositionFrom1Y +
                      headerRowHeight +
                      rowHeight * (rowIndex + 1) +
                      rowHeight / 2;
                    if (x.walking_time > 0) {
                      // 最後のインデックスで歩行の場合は一行目の高さにする
                      if (rowIndex === lineValueArr.length - 1) {
                        endY =
                          rowPositionFrom1Y + headerRowHeight + rowHeight / 2;
                      }
                      // 歩行時間描画
                      drawLine(
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * rowIndex +
                          rowHeight / 2,
                        xPos + x.walking_time * tickInTime,
                        endY,
                        "dash",
                        3,
                        "black"
                      );
                      xPos += x.walking_time * tickInTime;
                    }
                    // 最終行でタクトタイムのラインとテキスト出力
                    if (rowIndex === lineValueArr.length - 1) {
                      drawLine(
                        xPos,
                        rowPositionFrom1Y + headerRowHeight,
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * this.rowDataList.length,
                        "",
                        this.config.tactTimeLineWidth,
                        this.config.tactTimeLineColor
                      );

                      this.context2d.fillStyle = this.config.tactTimeTextColor;
                      this.context2d.textBaseline =
                        this.config.tactTimeTextBaseline;
                      this.context2d.lineWidth = 3;
                      this.context2d.fillText(
                        `タクトタイム:${
                          Math.round(((xPos - base) / tickInTime) * 10) / 10
                        }`,
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * this.rowDataList.length +
                          10
                      );
                    }
                  });
                };
              //↑↑↑↑↑ Please write your program. ↑↑↑↑↑

              global.JSPLUGIN.StandardWorkCombinationSlip = {
                _class_: StandardWorkCombinationSlip,
              };
            }.call(
              this,
              typeof global !== "undefined"
                ? global
                : typeof self !== "undefined"
                ? self
                : typeof window !== "undefined"
                ? window
                : {}
            ));
          },
          { "./PluginObject": 1 },
        ],
      },
      {},
      [2]
    );
  })();
})();
