(function () {
  (function () {
    (function () {
      function r(e, n, t) {
        function o(i, f) {
          if (!n[i]) {
            if (!e[i]) {
              var c = "function" == typeof require && require;
              if (!f && c) return c(i, !0);
              if (u) return u(i, !0);
              var a = new Error("Cannot find module '" + i + "'");
              throw ((a.code = "MODULE_NOT_FOUND"), a);
            }
            var p = (n[i] = { exports: {} });
            e[i][0].call(
              p.exports,
              function (r) {
                var n = e[i][1][r];
                return o(n || r);
              },
              p,
              p.exports,
              r,
              e,
              n,
              t
            );
          }
          return n[i].exports;
        }
        for (
          var u = "function" == typeof require && require, i = 0;
          i < t.length;
          i++
        )
          o(t[i]);
        return o;
      }
      return r;
    })()(
      {
        1: [
          function (require, module, exports) {
            (function (global) {
              //↓↓↓↓↓ Do not change. ↓↓↓↓↓
              function PluginObject(canvasId) {
                this.canvasId = canvasId;

                this.x = 0;
                this.y = 0;
                this.width = 0;
                this.height = 0;

                this.drillDown = null;
                this.drillUp = null;
                this.drillThrough = null;
                this.relation = null;
                this.dataPointAction = null;

                this.invalidateDisplayList = null;
                this.callLater = null;
              }

              PluginObject.prototype = {};
              PluginObject.prototype.constructor = PluginObject;
              module.exports = PluginObject;

              PluginObject.prototype.createChildren = function () {};

              PluginObject.prototype.updateDisplayList = function (
                width,
                height
              ) {};

              PluginObject.prototype.setConfig = function (config) {};

              PluginObject.prototype.setData = function (data, type) {};

              PluginObject.prototype.onMove = function (x, y) {
                this.x = x;
                this.y = y;
              };

              PluginObject.prototype.onResize = function (width, height) {
                this.width = width;
                this.height = height;
              };

              PluginObject.prototype.onMouseEvent = function (event) {};

              PluginObject.prototype.onKeyboardEvent = function (event) {};

              PluginObject.prototype.destroy = function () {};

              if (!global.JSPLUGIN) {
                global.JSPLUGIN = {};
              }
              //↑↑↑↑↑ Do not change. ↑↑↑↑↑
            }.call(
              this,
              typeof global !== "undefined"
                ? global
                : typeof self !== "undefined"
                ? self
                : typeof window !== "undefined"
                ? window
                : {}
            ));
          },
          {},
        ],
        2: [
          function (require, module, exports) {
            (function (global) {
              var PluginObject = require("./PluginObject");
              /**help
               * Please write the help text of this plugin here.
               */
              //↓↓↓↓↓ Please write your program. ↓↓↓↓↓
              function StandardWorkCombinationSlip(canvasId) {
                PluginObject.call(this, canvasId);

                //This is a sample.
                this.canvas = document.getElementById(canvasId);
                this.context2d = this.canvas.getContext("2d");
                this.config = {
                  font: "20px _sans",
                  fillStyle: "rgb(0, 0, 0)",
                  strokeStyle: "black",
                  tick: 10,
                  segmentCount: 11,
                  tactTimeLineColor: "red",
                  tactTimeLineWidth: 7,
                  tactTimeTextColor: "red",
                  tactTimeTextBaseline: "top",
                };
              }

              //↓↓↓↓↓ Do not change. ↓↓↓↓↓
              StandardWorkCombinationSlip.prototype = Object.create(
                PluginObject.prototype
              );
              StandardWorkCombinationSlip.prototype.constructor =
                StandardWorkCombinationSlip;
              module.exports = StandardWorkCombinationSlip;
              //↑↑↑↑↑ Do not change. ↑↑↑↑↑

              /**
               * Method called by MotionBoard when a plugin item's configuration string is set or changed.
               * @param {*} config
               * Setting Example
               * {
               *   "font": "italic 20px Arial",
               *   "fillStyle": "rgb(0, 0, 0)",
               *   "strokeStyle": "black",
               *   "tick": 10,
               *   "segmentCount": 11
               *   "tactTimeLineColor": "red",
               *   "tactTimeLineWidth": 7,
               *   "tactTimeTextColor": "red",
               *   "tactTimeTextBaseline": "top",
               * }
               * @memberof StandardWorkCombinationSlip
               * @method setConfig
               */
              StandardWorkCombinationSlip.prototype.setConfig = function (
                config
              ) {
                if (config === null || config.length === 0) {
                  return;
                }
                try {
                  const cfg = JSON.parse(config);
                  if ("font" in cfg) {
                    this.config.font = cfg.font;
                  }
                  if ("fillStyle" in cfg) {
                    this.config.fillStyle = cfg.fillStyle;
                  }
                  if ("strokeStyle" in cfg) {
                    this.config.strokeStyle = cfg.strokeStyle;
                  }
                  if ("tick" in cfg) {
                    this.config.tick = cfg.tick;
                  }
                  if ("segmentCount" in cfg) {
                    this.config.segmentCount = cfg.segmentCount;
                  }
                  if ("tactTimeLineColor" in cfg) {
                    this.config.tactTimeLineColor = cfg.tactTimeLineColor;
                  }
                  if ("tactTimeLineWidth" in cfg) {
                    this.config.tactTimeLineWidth = cfg.tactTimeLineWidth;
                  }
                  if ("tactTimeTextColor" in cfg) {
                    this.config.tactTimeTextColor = cfg.tactTimeTextColor;
                  }
                  if ("tactTimeTextBaseline" in cfg) {
                    this.config.tactTimeTextBaseline = cfg.tactTimeTextBaseline;
                  }
                } catch (err) {
                  this.error_message = "Invalid setting value." + err;
                }
              };

              StandardWorkCombinationSlip.prototype.setData = function (
                data,
                type
              ) {
                // Aggregate Item Data Acquisition
                this.sumDataList = data.pointDataList;

                /* Obtain row item data from MB data source
               Define an array for outputting row item values, eliminating duplicate row item values in this process, 
               since the values of the number of row items * number of aggregate items are obtained as an array. */
                this.rowDataList = [
                  ...new Map(
                    this.sumDataList.map((v) => [
                      v.colData.itemValue[0].value,
                      v,
                    ])
                  ).values(),
                ];
              };

              /**
               * Methods called by MotionBoard when drawing charts
               * @param {float}	width	Width of the plugin's drawing area
               * @param {float}	height	Height of the plugin's drawing area
               * @method updateDisplayList
               */
              StandardWorkCombinationSlip.prototype.updateDisplayList =
                function (width, height) {
                  // Initialize drawing area as transparent
                  this.context2d.clearRect(0, 0, width, height);

                  // Title character drawing parameters
                  this.context2d.strokeStyle = this.config.strokeStyle;
                  this.context2d.fillStyle = this.config.fillStyle;
                  this.context2d.lineWidth = 1;
                  this.context2d.textAlign = "center";

                  this.context2d.textBaseline = "middle";

                  this.context2d.font = this.config.font;
                  const ColPositionFrom1X = 50;
                  const ColWidth1 = 100;
                  // Header line output position
                  const rowPositionFrom1Y = 30;
                  // Header Row Height
                  const headerRowHeight = 80;
                  this.context2d.textBaseline = "bottom";

                  // Header text output
                  this.context2d.strokeRect(
                    ColPositionFrom1X,
                    rowPositionFrom1Y,
                    ColWidth1,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Sequence",
                    ColPositionFrom1X + ColWidth1 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth2 = 200;
                  this.context2d.strokeRect(
                    ColPositionFrom1X + ColWidth1,
                    rowPositionFrom1Y,
                    ColWidth2,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Tasks",
                    ColPositionFrom1X + ColWidth1 + ColWidth2 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth3 = 70;
                  this.context2d.strokeRect(
                    ColPositionFrom1X + ColWidth1 + ColWidth2,
                    rowPositionFrom1Y,
                    ColWidth3,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Manual",
                    ColPositionFrom1X + ColWidth1 + ColWidth2 + ColWidth3 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth4 = 70;
                  this.context2d.strokeRect(
                    ColPositionFrom1X + ColWidth1 + ColWidth2 + ColWidth3,
                    rowPositionFrom1Y,
                    ColWidth3,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Auto",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth5 = 70;
                  this.context2d.strokeRect(
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4,
                    rowPositionFrom1Y,
                    ColWidth3,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Walking",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth6 = 600;
                  this.context2d.strokeRect(
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5,
                    rowPositionFrom1Y,
                    ColWidth6,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Combined line diagram",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 +
                      ColWidth6 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const ColWidth7 = 400;
                  this.context2d.strokeRect(
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 +
                      ColWidth6,
                    rowPositionFrom1Y,
                    ColWidth7,
                    headerRowHeight
                  );
                  this.context2d.fillText(
                    "Remarks",
                    ColPositionFrom1X +
                      ColWidth1 +
                      ColWidth2 +
                      ColWidth3 +
                      ColWidth4 +
                      ColWidth5 +
                      ColWidth6 +
                      ColWidth7 / 2,
                    rowPositionFrom1Y + headerRowHeight / 2
                  );

                  const widthArr = [
                    ColWidth1,
                    ColWidth2,
                    ColWidth3,
                    ColWidth4,
                    ColWidth5,
                    ColWidth6,
                    ColWidth7,
                  ];
                  const rowHeight = 100;

                  this.context2d.textBaseline = "middle";
                  // Output of statement (Aggregate items)
                  // Line processing
                  for (let rowIndex = 0; rowIndex < 5; rowIndex++) {
                    const rowPosition =
                      rowPositionFrom1Y +
                      headerRowHeight +
                      rowHeight * rowIndex;
                    let ColWidthTotal = ColPositionFrom1X;

                    if (this.rowDataList.length <= rowIndex) {
                      break;
                    }

                    // String processing
                    for (
                      let colIndex = 0;
                      colIndex < widthArr.length;
                      colIndex++
                    ) {
                      const ColWidth =
                        colIndex == 0 ? 0 : widthArr[colIndex - 1];
                      ColWidthTotal += ColWidth;
                      this.context2d.strokeRect(
                        ColWidthTotal,
                        rowPosition,
                        widthArr[colIndex],
                        rowHeight
                      );

                      // Order column output
                      if (colIndex === 0) {
                        this.context2d.fillText(
                          rowIndex + 1,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                      // Value output of work content
                      if (colIndex === 1) {
                        this.context2d.fillText(
                          this.rowDataList[rowIndex].colData.itemValue[0].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }

                      // Manual operation time output
                      if (colIndex === 2) {
                        this.context2d.fillText(
                          this.sumDataList.filter(
                            (x) => x.summaryData.value === "manual_work_time"
                          )[rowIndex].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                      // Automatic time output
                      if (colIndex === 3) {
                        this.context2d.fillText(
                          this.sumDataList.filter(
                            (x) => x.summaryData.value === "auto_work_time"
                          )[rowIndex].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                      // Walking time output
                      if (colIndex === 4) {
                        this.context2d.fillText(
                          this.sumDataList.filter(
                            (x) => x.summaryData.value === "walking_time"
                          )[rowIndex].value,
                          ColWidthTotal + widthArr[colIndex] / 2,
                          rowPosition + rowHeight / 2
                        );
                      }
                    }
                  }

                  /**
                   * Canvas line drawing methods
                   * @param {number} startX - X starting point coordinates
                   * @param {number} startY - Y starting point coordinates
                   * @param {number} endX - X endpoint coordinates
                   * @param {number} endY - Y endpoint coordinates
                   * @param {string} lineType - linetype
                   * @param {string} [lineWidth] - Thickness (Default value is 1)
                   * @param {string} [color= "black"] - Line color (Default value is black)
                   * @param {MyClass} myClass - Arguments of the MyClass instance
                   */
                  const drawLine = (
                    startX,
                    startY,
                    endX,
                    endY,
                    lineType,
                    lineWidth = 1,
                    color = "black"
                  ) => {
                    // Line Parameter Setting
                    this.context2d.beginPath();
                    this.context2d.strokeStyle = color;
                    this.context2d.lineWidth = lineWidth;
                    if (lineType === "dash") {
                      this.context2d.setLineDash([20, 5]);
                    } else {
                      this.context2d.setLineDash([]);
                    }
                    // Initialization
                    this.context2d.moveTo(startX, startY);
                    // Point line endpoint designation
                    this.context2d.lineTo(endX, endY);
                    this.context2d.stroke();
                  };

                  // Dotted line output process for "Combination Diagram" column
                  const base =
                    ColPositionFrom1X +
                    ColWidth1 +
                    ColWidth2 +
                    ColWidth3 +
                    ColWidth4 +
                    ColWidth5;
                  this.context2d.textBaseline = "bottom";
                  const tactTimeSum = this.sumDataList
                    .filter((x) => x.summaryData.value != "auto_work_time")
                    .map((x) => x.value)
                    .reduce((sum, element) => sum + element, 0);

                  const configSumValue =
                    this.config.tick * this.config.segmentCount;
                  // Value per tick of column dotted line
                  const tick =
                    tactTimeSum > configSumValue
                      ? Math.floor(tactTimeSum / 10)
                      : this.config.tick;
                  const segmentCount =
                    tactTimeSum > configSumValue
                      ? 11
                      : this.config.segmentCount;

                  for (let i = 0; i <= segmentCount; i++) {
                    if (i === 0 || i === segmentCount) continue;
                    // Line X-coordinate
                    const linePositionX = base + (ColWidth6 / segmentCount) * i;

                    // Scale value output
                    this.context2d.fillText(
                      tick * i,
                      linePositionX,
                      rowPositionFrom1Y + headerRowHeight
                    );
                    // Combination Reference Line Drawing
                    drawLine(
                      linePositionX,
                      rowPositionFrom1Y + headerRowHeight,
                      linePositionX,
                      rowPositionFrom1Y +
                        headerRowHeight +
                        rowHeight * this.rowDataList.length,
                      "dash"
                    );
                  }

                  // Storing aggregate item data into an array of associative arrays for combination line drawing
                  let lineValueArr = [];
                  // Loop by number of work details
                  for (
                    let rowIndex = 0;
                    rowIndex < this.rowDataList.length;
                    rowIndex++
                  ) {
                    let valueDict = {};
                    let colIndex = 0;
                    // Loop for each of the three elements: manual, automatic, and walking
                    while (colIndex < 3) {
                      // Create an associative array with "Key: Working elements, Value: Time" and store it in the array.
                      valueDict[
                        this.sumDataList[
                          colIndex + 3 * rowIndex
                        ].summaryData.value
                      ] = this.sumDataList[colIndex + 3 * rowIndex].value;
                      colIndex++;
                    }
                    lineValueArr.push(valueDict);
                  }

                  const tactTime = lineValueArr
                    .map((x) => x.manual_work_time + x.walking_time)
                    .reduce((a, x) => a + x);

                  // One value in the scale (if one scale is "10", "1" is obtained here)
                  const tickInTime = ColWidth6 / segmentCount / tick;
                  let xPos = base;
                  // Combination line output process for each line
                  lineValueArr.map((x, rowIndex) => {
                    // Automatic operation time is
                    const xPosOffset =
                      x.auto_work_time + x.manual_work_time > tactTime
                        ? x.auto_work_time + x.manual_work_time - tactTime
                        : 0;

                    xPos = xPos + xPosOffset * tickInTime;
                    // Manual time drawing
                    drawLine(
                      xPos,
                      rowPositionFrom1Y +
                        headerRowHeight +
                        rowHeight * rowIndex +
                        rowHeight / 2,
                      xPos + x.manual_work_time * tickInTime,
                      rowPositionFrom1Y +
                        headerRowHeight +
                        rowHeight * rowIndex +
                        rowHeight / 2,
                      "",
                      10,
                      "red"
                    );
                    xPos += x.manual_work_time * tickInTime;

                    if (x.auto_work_time > 0) {
                      const xAutoEnd =
                        xPos + x.auto_work_time * tickInTime >
                        base + tactTime * tickInTime
                          ? base +
                            tactTime * tickInTime +
                            xPosOffset * tickInTime
                          : xPos + x.auto_work_time * tickInTime;

                      // When the end of automatic operation time exceeds the takt time
                      if (
                        xPos + x.auto_work_time * tickInTime >
                        base + tactTime * tickInTime
                      ) {
                        const wraoOffsetY = 20;
                        // Automatic operation output (turn back)
                        drawLine(
                          base,
                          rowPositionFrom1Y +
                            headerRowHeight +
                            rowHeight * rowIndex +
                            rowHeight / 2 +
                            wraoOffsetY,
                          (xPos / tickInTime +
                            x.auto_work_time -
                            tactTime -
                            xPosOffset) *
                            tickInTime,
                          rowPositionFrom1Y +
                            headerRowHeight +
                            rowHeight * rowIndex +
                            rowHeight / 2 +
                            wraoOffsetY,
                          "dash",
                          3,
                          "blue"
                        );
                      }

                      // Automatic operation output (after manual operation)
                      drawLine(
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * rowIndex +
                          rowHeight / 2,
                        xAutoEnd,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * rowIndex +
                          rowHeight / 2,
                        "dash",
                        3,
                        "blue"
                      );
                    }

                    // Walking time output
                    let endY =
                      rowPositionFrom1Y +
                      headerRowHeight +
                      rowHeight * (rowIndex + 1) +
                      rowHeight / 2;
                    if (x.walking_time > 0) {
                      // If walking at the last index, make the height of the first row
                      if (rowIndex === lineValueArr.length - 1) {
                        endY =
                          rowPositionFrom1Y + headerRowHeight + rowHeight / 2;
                      }
                      // Walking time drawing
                      drawLine(
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * rowIndex +
                          rowHeight / 2,
                        xPos + x.walking_time * tickInTime,
                        endY,
                        "dash",
                        3,
                        "black"
                      );
                      xPos += x.walking_time * tickInTime;
                    }
                    // Tact time line and text output on last line
                    if (rowIndex === lineValueArr.length - 1) {
                      drawLine(
                        xPos,
                        rowPositionFrom1Y + headerRowHeight,
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * this.rowDataList.length,
                        "",
                        this.config.tactTimeLineWidth,
                        this.config.tactTimeLineColor
                      );

                      this.context2d.fillStyle = this.config.tactTimeTextColor;
                      this.context2d.textBaseline =
                        this.config.tactTimeTextBaseline;
                      this.context2d.lineWidth = 3;
                      this.context2d.fillText(
                        `Takt Time:${
                          Math.round(((xPos - base) / tickInTime) * 10) / 10
                        }`,
                        xPos,
                        rowPositionFrom1Y +
                          headerRowHeight +
                          rowHeight * this.rowDataList.length +
                          10
                      );
                    }
                  });
                };
              //↑↑↑↑↑ Please write your program. ↑↑↑↑↑

              global.JSPLUGIN.StandardWorkCombinationSlip = {
                _class_: StandardWorkCombinationSlip,
              };
            }.call(
              this,
              typeof global !== "undefined"
                ? global
                : typeof self !== "undefined"
                ? self
                : typeof window !== "undefined"
                ? window
                : {}
            ));
          },
          { "./PluginObject": 1 },
        ],
      },
      {},
      [2]
    );
  })();
})();
